#!/usr/bin/env python
# -*- coding: utf-8 -*-

patterns = [
    (
        "season",
        "[\. ]((?:Complete.)?s[0-9]{2}-s[0-9]{2}|"
        "s([0-9]{1,2})(?:e[0-9]{2})?|"
        "([0-9]{1,2})x[0-9]{2})(?:[\. ]|$)",
    ),

    ("episode", "((?:[ex]|ep)([0-9]{2})(?:[^0-9]|$))"),
    ("year", "([\[\(]?((?:19[0-9]|20[0-9])[0-9])[\]\)]?)"),
    ("resolution", "([0-9]{3,4}[pi]|1280x720)"),

    (
        "quality",
        (
            "((?:PPV\.)?[HP]DTV|(?:HD|HQ)?CAM|CamRip|(?<!D)(?:HD[.-]?)?TS|tsrip|"
            "(?:PPV )?WEB[.-]?DL(?: DVDRip)?|HDRip|(?:HD)?TVRip|DVD[.-]?Rip|DCP[.-]?Rip|"
            "W[EB]BRip|Blu[.-]?Ray|B[DR][.-]?(?:Rip|Remux)|DvDScr|hdtv|telesync|telecine|screener|scr|R5)"
        ),
    ),

    ("codec", "(mpeg-?[124]?|xvid|[hx]\.?26[45]|hevc|avc|(?:av|vc-?)1|HDR(?:10)?(?:plus)?|DolbyVision|DoVi|DV(?!d)|\d{2,3}fps)" ),

    ("audio",
        "((?:WMA|FLAC|L?PCM|DDP?(?:[.-]?EX)?|DTS(?:[.-]?(?:HD|ES|EX|X(?!26))(?:[. ]MA)?)?|E?-?AC-?3|(?:HE-)?AAC(?:[ .-]LC|v2)?|TRUEHD(?:[ .]atmos)?|atmos)(?:[ .-]?[572461]\.[102])?(?:(?:\.[24])?[ .]atmos)?"
        "|MD|MP3|Dual[ -]Audio|LiNE|(?:custom|dual)[. ]audio|dual)"
    ),

    ("group", "(- ?([^-]+(?:-={[^-]+-?$)?))$"),
    ("region", "R[0-9]"),
    ("extended", "(EXTENDED(?=.CUT)?|(?:directors|alternat(?:iv)?e)(?:.CUT))"),
    ("remastered", "(REMASTERED|Rekonstrukcja(?:[. ]cyfrowa)?)"),
    ("hardcoded", "HC"),
    ("proper", "PROPER"),
    ("repack", "REPACK"),
    ("container", "(?<=\.)\w{2,4}$"),  # the extension can be from 2 to 4 characters
    ("widescreen", "WS"),
    ("website", "^(\[ ?([^\]]+?) ?\])"),
    ("language", "(rus\.eng|ita\.eng|nordic|eng?|po?l|mul(?:ti)?|ita?|esp?|fra?|de|rus?)"),
    ("subtitles", "((?:DK|EN|PL)?(?:subs?|subbed|napisy))"),
    ("sbs", "(?:Half-)?SBS"),
    ("unrated", "UNRATED"),
    ("size", "(\d+(?:\.\d+)?(?:GB|MB))"),
    ("3d", "3D"),
    ("imax", "IMAX"),
]

types = {
    "season": "integer",
    "episode": "integer",
    "year": "integer",
    #"extended": "boolean",
    #"remastered": "boolean",
    "hardcoded": "boolean",
    "proper": "boolean",
    "repack": "boolean",
    "widescreen": "boolean",
    "unrated": "boolean",
    "3d": "boolean",
    "imax": "boolean",
}

bt_sites = ["eztv", "ettv", "rarbg", "rartv", "ETRG"]
